      program    mprep
      character*(*) verson
      parameter (verson = 'Version X.4 (01-09-92)')
C
C    *******************************************************************
C    *                                                                 *
C    * MAIN PROGRAM F419. FORTRAN IV VERSION OF PROGRAM T419.          *
C    * THIS PROGRAM PREPARES THE MAGNETIC TAPE INPUT FOR PROGRAM F418. *
C    * FORTRAN IV VERSION                          DECEMBER 1972       *
C    * H.M.RIETVELD, REACTOR CENTRUM NEDERLAND, PETTEN(N.H.)           *
C    *                                                                 *
C    *******************************************************************
C    *                                                                 *
C    * THIS VERSION FOR PREPARATION OF DATA CONTAINING MORE THAN ONE   *
C    * PATTERN                                     NOVEMBER 1977       *
C    * P.J.BENDALL, INORGANIC CHEMISTRY LABORATORY, OXFORD             *
C    *******************************************************************
C    *                                                                 *
C    * THIS VERSION MODIFIED FOR STEP LENGTHS LESS THAN 1/100TH OF A   *
C    * DEGREE (GREATER THAN 1/1000TH) - FULLY COMPATIBLE WITH PREVIOUS *
C    * DATASETS                                                        *
C    * A.D.MURRAY, DEPT CHEMISTRY UNIVERSITY COLLEGE LONDON    06/01/87*
C    *******************************************************************
C    *                                                                 *
C    * Added facility to allow refineable background function in MPROF *
C    * A.D. Murray                                             16/03/87*
C    *******************************************************************
C    *                                                                 *
C    * NON-STANDARD FEATURES :                                         *
C    *                                                                 *
C    * Input/output units in PREPROF (MAIN)                            *
C    *                                                                 *
C    * OPEN and INQUIRE statements in subroutine FILEIN                *
C    *                                                                 *
C    * All non-standard sections are maked with a card begining;       *
C    * " CNON* "                                                       *
C    *******************************************************************
C    *                    VARIABLE DIMENSIONS                          *
C    *      N=MAXIMUM NUMBER OF REFLECTIONS                            *
C    *      B=MAXIMUM NUMBER OF BACKGROUND POSITIONS                   *
C    *      L=MAXIMUM NUMBER OF EXCLUDED REGIONS                       *
C    *      I=MAXIMUM NUMBER OF PROFILE INTENSITIES                    *
C    *                              *****                              *
C    *                 ARRAYS WITH VARIABLE DIMENSIONS                 *
C    *     BAK(B)              TT(N)               HWL(N)              *
C    *     IHILO(N)            IH(3,N)             HIGH(L)             *
C    *     ICM(N)              INDEX(N)            RLOW(L)             *
C    *     YY(I)               LL(N)               T(N)                *
C    *     PLOR(N)             POS(B)              SLABDA(2)           *
C    *******************************************************************
C                            ******************
C                            * PRESENT VALUES *
C                            *      N =3000   *
C                            *      B =  99   *
C                            *      L =  10   *
C                            *      I =18000  *
C                            ******************
C                       ****************************
C                       *   NOUT   = LINEPRINTER   *
C                       *   INCRD  = CARDREADER    *
C                       *   IBIN   = TAPE FILE DATA*
C                       *            SET ON DISK   *
C                       *   INF    = OPTIONAL DATA *
C                       *            INPUT FILE    *
C                       ****************************
C
C
      dimension a(3,3),bak(99),dumpa(500),slabda(2),hwl(3000),ih(3,
     2 3000),high(10),index(3000),rlow(10),nh(3,3),plor(3000),pos(99),
     3 atext(20),tt(3000),yy(18000),ht(18000),icm(3000),ihilo(18000)
      dimension bcell(3,3,3),p(3),q(3),r(3),ww(18000)
C
C
      common /units/ ibin,incrd,nout,inf

      common dumpa,ii,nkey,atext,ntext,kstart
      common tl(3000),ll(3000)
C
      character*80 linein, files(1), binfil
      character*30 word, feline
      double precision value,alfa,stap,omeg,sis,atti,omegf
      real             dalfa,dstap,domeg
      integer units(4)
      dimension        value(8),word(3)
      logical          error,angcou
C
C
      data nox/3hno./,blank/4h    /

*     Call PDPL stuff

      call pdpl('MPREP',verson)
C MODIF A. JOUANNEAUX
C      call condom
      call pdplfs(4,1,units,files)

C     SET VALUES FOR INPUT/OUTPUT UNITS

      incrd = units(1)
      nout = units(2)
      ibin = units(3)
      inf = units(4)
      binfil = files(1)
      call setsio(incrd,nout,' ')

*     Open binary file

      call gfile(ibin, binfil, 'OVW', 'UNF', 0, error, nout)

      if (error) then
          write(nout,1000)
 1000     format(/' Cannot allocated binary file'//
     &            ' Program forced to terminate'/)
          call endall
      endif


C.....SET INPUT MODE
      inmode = 0
C
C.....WHEN ANGLES IN 1/100TH DEGREES,FOLLOWING STATEMENT SHOULD READ:
C     RAD=3.14159265359/36000.
      rad=3.14159265359/36000.
C.....READ AND PRINT TITLE
10    write(nout,650) verson
      read(incrd,670)atext
      write(nout,910)atext
C.....CLEAR DUMP ARRAYS
      do 20 i=1,500
20    dumpa(i)=0.
C
      do 25 i=1,1000
      hwl(i)=0.0
      index(i)=0
      tt(i)=0.0
      tl(i)=0.0
      ll(i)=0
      plor(i)=0.0
      icm(i)=0
        do 27 j=1,3
27      ih(j,i)=0
25    continue
      do 28 i=1,3
      p(i)=0.0
      q(i)=0.0
      r(i)=0.0
        do 29 j=1,3
        a(j,i)=0.0
        nh(j,i)=0
          do 29 k=1,3
          bcell(k,j,i)=0.0
29      continue
28    continue
      do 31 i=1,10
      high(i)=0.
31    rlow(i)=0.
      npat=0
      nkey=0
      ii=0
      lineno = 1
C.....READ AND PRINT NUMBER OF PATTERNS
      call initt(linein,lineno)
      call digits(linein,value,2,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      npat=value(1)
      if(npat.eq.0)npat=1
      iwhole=value(2)
      call dump(12345.)
      call dump(blank)
C
C.....READ CELL DIMENSIONS FOR EACH PATTERN
      do 40 i=1,npat
      write(nout,950)i
      write(nout,920)
      call cell(a)
      do 30 j=1,3
      do 30 k=1,3
30    bcell(i,k,j)=a(k,j)
40    continue
C.....READ AND PRINT WAVELENGTH(S),ZEROPOINT.....
      call initt(linein,lineno)
      call digits(linein,value,5,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      zero=value(1)
      slabda(1)=value(2)
      slabda(2)=value(4)
      wdt=value(3)
      cthm=value(5)
      if(cthm.le.0.001)cthm=1.0
      if(wdt.lt..001)wdt=1.5
      write(nout,810)slabda(1),slabda(2)
      write(nout,820)zero
      write(nout,70)wdt
      write(nout,50)cthm
      if (iwhole.eq.1) then
      write(nout,80)
      else if (iwhole.eq.2) then
      write(nout,81)
      endif
50    format(' Monochromator Constant  =',f8.4/)
70    format(23h base of peak = 2.0*hw*,f8.2/)
80    format(' Refinement of total profile chosen -',
     &       ' No background correction will be made'/)
81    format(' Refinement of total profile chosen -',
     &       ' Background correction will be made'/)
C.....READ AND PRINT HALFWIDTH PARAMETERS FOR EACH PATTERN
      do 90 kj=1,npat
      call initt(linein,lineno)
      call digits(linein,value,3,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      p(kj)=value(1)
      q(kj)=value(2)
      r(kj)=value(3)
      write(nout,830)kj
      write(nout,930)
      write(nout,840)p(kj),q(kj),r(kj)
90    continue
C.....READ BACKGROUND ESTIMATES
      i=1
100   continue
      call initt(linein,lineno)
      call digits(linein,value,2,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      pos(i)=value(1)
      bak(i)=value(2)
      if(pos(i)+100.)110,120,110
110   i=i+1
      goto 100
120   continue
      if (iwhole.ne.1) then
      nb=i-1
      write(nout,850)
      write(nout,860)(pos(i),bak(i),i=1,nb)
      else
      nb=0
      endif
      call initt(linein,lineno)
      call digits(linein,value,2,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      n=value(1)
      high(1)=value(2)
C.....WHEN N IS NEGATIVE,THE LOWER AND UPPER LIMITS OF THOSE PARTS OF
C     THE DIAGRAM,WHICH HAVE TO BE EXCLUDED FROM THE CALCULATIONS, HAVE
C     TO BE READ IN.
      ncu=0
      if(n)130,200,200
130   i=1
140   if(i-1)160,150,160
150   rlow(i)=-value(1)
      high(i)=-high(i)
      goto 170
160   continue
      call initt(linein,lineno)
      call digits(linein,value,2,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      rlow(i)=-value(1)
      high(i)=-value(2)
170   if(rlow(i)-100.)180,190,180
180   i=i+1
      goto 140
190   ncu=i-1
      write(nout,880)
      write(nout,890)(rlow(i),high(i),i=1,ncu)
      call initt(linein,lineno)
      call digits(linein,value,1,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      n=value(1)
200   if(ncu.eq.0)write(nout,870)
C.....READ IN DENOMINATORS OF MILLER INDICES
      do 220 kj=1,npat
      call initt(linein,lineno)
      call digits(linein,value,3,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      do 210 i=1,3
      nh(kj,i)=value(i)
210   continue
220   continue
C.....READ REFLECTIONS AND CALCULATE FOR EACH THE LORENTZ
C     FACTOR,THE POSITION AND THE HALFWIDTH.
      nref=n
      i=1
      do 260 iii=1,nref
C     READ(INCRD,700)ICODE,(IH(J,I),J=1,3),M
      call initt(linein,lineno)
      call digits(linein,value,5,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      icode = value(1)
      ih(1,i) = value(2)
      ih(2,i) = value(3)
      ih(3,i) = value(4)
      m = value(5)
      d=0.
      if(icode.lt.10)icode=icode+10
      icm(i)=100*icode+m
C.....BREAK UP COMPOSITE CODEWORD INTO PATTERN AND TYPE
      kj=icode/10
      ic=icode-10*kj
      icodd=ic
      if(ic.gt.5) icode = kj*10 + 4
      if(ic.le.4)ic=1
      if(ic.eq.5)ic=2
      do 230 j=1,3
      do 230 k=j,3
230   d=bcell(kj,j,k)*ih(j,i)*ih(k,i)/(nh(kj,j)*nh(kj,k))+d
      dlabda=0.25*slabda(ic)*slabda(ic)
      d=dlabda*d
      if(d-1.0)250,250,240
240   n=n-1
      goto 260
250   continue
C     LORENTZ FACTOR
      plor(i)=1./(2.*d*sqrt(1.-d))
C     MULTIPLY BY POLARIZATION FACTOR IF X-RAY GENERATOR TYPE RADIATION
      if(icodd.ge.4)plor(i)=plor(i)
     1   *(1.+(1.-2.*d)*(1.-2.*d)*cthm)
      tan=sqrt(d/(1.-d))
      tl(i)=atan(tan)/rad+zero
      hwl(i)=sqrt(p(kj)*tan*tan+q(kj)*tan+r(kj))
      index(i)=0
      i=i+1
260   continue
      nref=nref-n
      call sort(n)
C
C.....READ PROFILE INTENSITIES
      call initt(linein,lineno)
      call text(linein,word,3,1,kend,nfnd,30,error,6)
       call upcase(word(1))
       call upcase(word(3))
       if (word(1).eq.'DATA'.or.word(1).eq.'FILE') then
       feline =  word(2)
       inmode = 1
        if (word(3).eq.'D1A'.or.word(3).eq.'D2B') then
        inflag = 1
        else if (word(3).eq.'HAR') then
        inflag = 2
        else if (word(3).eq.'PDS') then
        inflag = 3
        else
        write(nout,9000) word(3)
 9000   format(/' ERROR - unrecognised file format : ',a30/
     1          ' PROGRAM FORCED TO TERMINATE'///)
        call endall
        endif
        kss = kend
        else
        kss = 1
       endif
      call digits(linein,value,3,kss,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
       if (inmode.eq.0) then
       alfa = value(1)
       if (alfa.le.10.) angcou = .true.
       stap = value(2)
       omeg = value(3)
       inflag = 1
       else
       alfa = value(1)
       omeg = value(2)
       call filein(feline,inflag,alfa,stap,omeg)
        if(inflag.eq.2) then
        angcou = .true.
        else
        angcou = .false.
        endif
       incrd = inf
      endif
      write(nout,681)
      do 271 kj=1,npat
      write(nout,690)kj,(nh(kj,i),i=1,3)
 271  continue
      write(nout,270)nref
270   format(1h0,i5,
     2 54h reflections rejected with sine theta greater than 1.0/)
      write(nout,680)
      if (iwhole.ne.1) then
      pos(nb+1)=omeg+stap
      bak(nb+1)=bak(nb)
      endif
      maxr=n
C     PI=FLOAT(ISTAP)/(100.*SQRT(RAD))
      pi=stap/(100.*sqrt(rad))
      jj=1
      i=1
      minr=1
      sis=alfa
280   if(.not.angcou)goto 290
      read(incrd,*)ht(jj),yy(jj)
      ww(jj) = 1.0
      sis=ht(jj)
      goto 300
290   j=jj-(jj-1)/10*10
      jj9=jj+9
       if(j.eq.1)then
        if (inflag.eq.1) then
C.....READ IN ONE RECORD OF 10 INTENSITIES
        read(incrd,720,err=641,end=400) (ww(j),yy(j),j=jj,jj9)
        if (yy(jj).eq.-1000.0) goto 400
        else if (inflag.eq.3) then
        read(incrd,721,err=641,end=400)(ww(j),j=jj,jj9)
        read(incrd,721,err=641,end=400)(yy(j),j=jj,jj9)
        if (yy(jj).eq.-10000.0) goto 400
        endif
      endif
300   y=yy(jj)
C.....DETERMINE WHETHER INTENSITY IS IN EXCLUDED RANGE
      lowj=0
      ihighj=0
      if(ncu)330,330,310
310   do 320 j=1,ncu
      if((sis.ge.rlow(j)).and.(sis.le.high(j)))y=0.
320   yy(jj)=y
330   if(y.eq.0.)goto 390
      mark=0
C.....DETERMINE WHAT REFLECTIONS CAN CONTRIBUTE TO INTENSITY I.E. ARE
C     WITHIN 1.5*HALFWIDTH FROM INTENSITY POSITION.
      do 370 j=minr,maxr
      lls=ll(j)
      width=hwl(lls)*wdt
      st=tl(lls)
      min=st-width+0.5
      max=st+width+0.5
      if(.not.((sis.ge.min).and.(sis.le.max)))goto 360
      if(mark)350,340,350
340   i=j
      lowj=j
      mark=1
350   index(j)=-1
      goto 370
360   if(mark.eq.1)goto 380
370   continue
380   if(mark.eq.1)ihighj=j-1
      minr=i
390   sis=sis+stap
      idelt=ihighj-lowj
      ihilo(jj)=10000*idelt+lowj
      jj=jj+1
      if(sis-omeg)280,280,400
C.....DETERMINE MAXIMUM NUMBER OF OVERLAPPING REFLECTIONS FOR ANY
C.....INTENSITY.
400   continue
      omeg = sis - stap
C     REMOVE TRAILING ZEROS
      jal = jj
401   continue
      jal = jal - 1
      if (yy(jal).le.0.0) then
      omeg = omeg - stap
      goto 401
      endif
      omegf = omeg + stap
      olim=1.
      jj1=jj-1
      do 410 i=1,jj1
      lowj=mod(ihilo(i),10000)
      idelt=ihilo(i)/10000
      ihighj=lowj+idelt
C.....DETERMINE TOTAL NUMBER OF REFLECTIONS WITHIN RANGE CONCERNED
      if (iwhole.eq.0) then
      if(lowj.eq.0)yy(i)=0.
      endif
      y=ihighj-lowj
410   if(y.gt.olim)olim=y
      olim=olim+1.
      if(olim.gt.60.)olim=60.
      i=0
      do 420 is=1,n
      if(index(is).eq.-1)i=i+1
420   continue
C.....WRITE DATA ON TAPE AND PRINT REFLECTIONS
      call dump(olim)
      call dump(float(i))
      do 430 kj=1,npat
      do 430 i=1,3
430   call dump(float(nh(kj,i)))
      i=0
      do 470 is=1,n
      lls=ll(is)
      m=mod(icm(lls),100)
      icode=icm(lls)/100
      iz=0
      if(index(is).eq.-1)iz=1
      if(iz-1)460,440,460
440   i=i+1
      tt(is)=i
      call dump(float(icode))
      do 450 j=1,3
450   call dump(float(ih(j,lls)))
      xx=float(m)*pi*plor(lls)
      call dump(xx)
      write(nout,730)i,icode,(ih(j,lls),j=1,3),m,hwl(lls),tl(lls)
      goto 470
460   tt(is)=0.
      write(nout,740)icode,(ih(j,lls),j=1,3),m,hwl(lls),tl(lls)
470   continue
C.....CORRECT FOR BACKGROUND AND PRINT PROFILE INTENSITIES
      write(nout,900)alfa,omeg,stap
      limo=olim+0.5
      write(nout,760)(nox,i=1,limo)
      dalfa = alfa
      dstap = stap
      domeg = omeg
      call dump(dalfa)
      call dump(dstap)
      call dump(domeg)
      atti=alfa
      jj=1
      iz=0
      nz=0
480   y=yy(jj)
      watx=ww(jj)
      lowj=mod(ihilo(jj),10000)
      idelt=ihilo(jj)/10000
      ihighj=lowj+idelt
      if(angcou)atti=ht(jj)
      if(y)500,490,500
490   nz=nz+1
      iz=1
      call dump(0.)
      if(angcou)call dump(sngl(atti))
      goto 630
500   continue
C     SKIP BACKGROUND SUBTRACTION IF TOTAL PATTERN REQUIRED
      if (iwhole.eq.1) then
      back = 0.0
      goto 530
      endif
      nb1=nb+1
      do 520 j=1,nb1
      j1=j-1
      if(j1.eq.0)j1=1
      if(pos(j).le.atti)goto 520
      back=bak(j1)
      if(j-j1)530,530,510
510   back=back+(atti-pos(j1))/(pos(j)-pos(j1))*(bak(j)-bak(j1))
      goto 530
520   continue
530   continue
      w = watx
      w=w*250./(y+back)
      yl=y-back
      if (abs(yl).le.0.002) yl=0.002
      iii=0
540   if(iz-1)600,550,600
550   if(nz-4)560,560,570
560   write(nout,770)(iii,k=1,nz)
      goto 580
570   write(nout,770)(iii,k=1,2)
      nz4=nz-4
      write(nout,780)nz4
      write(nout,770)(iii,k=1,2)
580   if(atti-omegf)590,590,640
590   iz=0
      nz=0
600   call dump(yl)
      call dump(w)
C     SKIP IF TOTAL PATTERN REQUIRED AND NO REFLECTIONS CONTRIBUTE
C     AT THIS PARTICULAR POINT
      if (lowj.eq.0) then
      k1=0
      k2=0
      goto 620
      endif
      k1=lowj
      k1=tt(k1)+0.5
      k2=ihighj
      k2=tt(k2)+0.5
      kd=k2-k1+1
      if(kd.le.60)goto 620
      write(nout,610)k1,k2
610   format(6h refl ,i4,14h through refl ,i4,
     2 58h contribute to this observation, only 60 of these are used)
      k1=k1+(kd-60)/2
      k2=k2-(kd-59)/2
620   call dump(float(k1))
      call dump(float(k2))
      if(angcou)call dump(sngl(atti))
      if(k2-1000)623,622,622
622   write(nout,795)atti,y,back,yl,w,(k,k=k1,k2)
      goto 630
623   write(nout,790)atti,y,back,yl,w,(k,k=k1,k2)
630   atti=atti+stap
      jj=jj+1
      if(atti.le.omegf)goto 480
      if(iz.eq.1)goto 540
640   call dump(-12345.)
      write(nout,800)

*     Close binary file

      call gfile(ibin, binfil, 'CLK', 'UNF', 0, error, nout)

      call endall
641   continue
      write(nout,642)
642   format(/' ERROR - profile data corrupted'/
     &        ' PROGRAM FORCED TO TERMINATE'///)
      call endall
650   format(/' PREPARATION OF POWDER PROFILES FOR NUCLEAR, MAGNETIC'
     1,' AND X-RAY STRUCTURE REFINEMENT PROGRAM'
     1,' - FORTRAN 77  MULTIPATTERN VERSION 1987'/
     2 ' BASED ON THE METHOD OF RIETVELD (1969)',54x,a)
670   format(20a4)
681   format('1'/' Reflection list'/
     1           ' ---------------'//
     2 ' Denominators of Miller indices'//
     3 '       Pattern   h   k   l'/)
680   format(/51h0   no.  code    h   k   l   mult     hw       posn)
690   format(8x,i4,2x,3i4)
700   format(5i8)
710   format(3i8)
720   format(10(f2.0,f6.0))
721   format(10f8.0)
730   format(1x,i5,i6,2x,3i4,i6,f9.1,f11.1)
740   format(7h    ***,i6,2x,3i4,i6,f9.1,f11.1)
750   format(1h0,3i6)
760   format(42h0    posn   i+b      b     i       w      ,
     2 20(a3,1x)/1h ,39x,20(a3,1x))
770   format(3x,i12)
780   format(8x,1h(,i4,7h zeros))
790   format(1x,f8.1,3f7.0,f9.4,20i4/37x,20i4,/,37x,20i4)
795   format(1x,f8.1,3f7.0,f9.4,15i5/37x,15i5/37x,15i5/37x,15i5)
800   format(1x,119(1h+))
810   format(15h0wavelength(s)=,2f7.4)
820   format(11h0zeropoint=,f6.2)
830   format(22h0halfwidth parameters ,1x,11hfor pattern,i2)
840   format(3h u=,f9.1,3x,2hv=,f9.1,3x,2hw=,f9.1)
850   format(12h0background=/9h position,4x,9hintensity)
860   format(1x,f7.0,6x,f6.0)
870   format(21h0no excluded regions.)
880   format(18h0excluded regions=/5h from,8x,2hto)
890   format(1x,f8.1,4x,f8.1)
900   format(13h1diagram from,f8.1,1x,2hto,f8.1,1x,11hin steps of,
     2 f6.1,1x,15h1/100ths degree,///)
910   format(/1x,20a4)
920   format(1x,29(1h-))
930   format(1x,35(1h-))
940   format(i8,f8.0)
950   format(//,28h cell dimensions for pattern,i2)
      end
      subroutine cell(x)
C     ***********************************************************
C     THE SUBROUTINE CELL READS EITHER DIRECT CELL PARAMETERS AND
C     CONVERTS THESE TO CELL CONSTANTS,WHICH ARE PLACED IN ARRAY X OR
C     READS CELL CONSTANTS AND PRINTS THE DIRECT CELL PARAMETERS.
C     ***********************************************************
C
C
      common /units/ ibin,incrd,nout,inf

      dimension x(3,3)
C
C
      character        linein*80
      double precision value
      dimension        value(8)
      logical          error
C
      rad=3.14159265359/180.
      idisml=-1
      nread=6
      call initt(linein,lineno)
      call digits(linein,value,6,1,kend,nfnd,error,6)
      if (error) call fatal(lineno,linein)
      a=value(1)
      b=value(2)
      c=value(3)
      d=value(4)
      e=value(5)
      f=value(6)
      isw=0
      if(a.lt.1.)isw=1
      if(isw.eq.0)goto 10
      x(1,1)=a
      x(2,2)=b
      x(3,3)=c
      x(1,2)=f
      x(1,3)=e
      x(2,3)=d
      a=sqrt(a)
      b=sqrt(b)
      c=sqrt(c)
      cosa=d/(2.*b*c)
      cosb=e/(2.*a*c)
      cosc=f/(2.*a*b)
      goto 20
10    cosa=cos(rad*d)
      cosb=cos(rad*e)
      cosc=cos(rad*f)
20    sina=sqrt(1.-cosa*cosa)
      sinb=sqrt(1.-cosb*cosb)
      sinc=sqrt(1.-cosc*cosc)
      v=a*b*c*sqrt(1.-cosa*cosa-cosb*cosb-cosc*cosc+2.*cosa*cosb*cosc)
      as=b*c*sina/v
      bs=c*a*sinb/v
      cs=a*b*sinc/v
      cosas=(cosb*cosc-cosa)/(sinb*sinc)
      cosbs=(cosc*cosa-cosb)/(sinc*sina)
      coscs=(cosa*cosb-cosc)/(sina*sinb)
      if(isw.eq.0)goto 30
      a=as
      b=bs
      c=cs
      d=atan2(sqrt(1.-cosas*cosas),cosas)/rad
      e=atan2(sqrt(1.-cosbs*cosbs),cosbs)/rad
      f=atan2(sqrt(1.-coscs*coscs),coscs)/rad
      goto 40
30    x(1,1)=as*as
      x(2,2)=bs*bs
      x(3,3)=cs*cs
      x(1,2)=2.*as*bs*coscs
      x(1,3)=2.*as*cs*cosbs
      x(2,3)=2.*bs*cs*cosas
40    write(nout,50)a,b,c,d,e,f
50    format(3h a=,f8.4,6x,2hb=,f8.4,6x,2hc=,f8.4/7h alpha=,f7.3,3x,
     2 5hbeta=,f7.3,4x,6hgamma=,f7.3)
      return
      end
      subroutine dump(x)
C     *********************************************************
C     THE SUBROUTINE DUMP STORES THE VALUE X IN ARRAY DUMPA.
C     WHEN THIS HAS BEEN FILLED,ITS CONTENTS ARE TRANSFERRED TO
C     A TEMPORARY DATA SET ON DISC IN RECORDS OF 500 MUMBERS.
C     ********************************************************
C
C
      common /units/ ibin,incrd,nout,inf

      common dumpa(500),ii,nkey,atext(20),ntext,kstart
      common tl(3000),ll(3000)
      ii=ii+1
      dumpa(ii)=x
      if(ii.ne.500)goto 20
      write(ibin)dumpa
      ii=0
20    if(x.ne.-12345.)goto 30
      write(ibin)dumpa
      dumpa(1)=-12345.
      write(ibin)dumpa
      endfile ibin
      rewind ibin
30    return
      end
      subroutine sort(n)
C     ********************************************************
C     THE SUBROUTINE SORT APPLIES TO THE ARRAY A WITH J ELEMENTS.
C     THE INDICES OF THE ORDERED ARRAY ARE PLACED IN ARRAY L
C     TO OBTAIN THE ORDERED ARRAY REPLACE THE INDICES I OF A(I)
C     WITH I=L(I)---REF.CACM 271
C     *********************************************************
C
C
      common /units/ ibin,incrd,nout,inf

      dimension iut(10),ilt(10),atext(20)
C
      common dumpa(500),ii,nkey,atext,ntext,kstart
      common a(3000),l(3000)
      j=n
      i=1
      m=1
      do 10 k=1,j
10    l(k)=k
20    if(j-i-1)140,140,30
30    ip=(j+i)/2
      itt=l(ip)
      t=a(itt)
      l(ip)=l(i)
      iq=j
      k=i+1
40    if(k.gt.iq)goto 90
      lk=l(k)
      if(a(lk).le.t)goto 80
      iq=iq
50    if(iq.lt.k)goto 70
      lq=l(iq)
      if(a(lq).ge.t)goto 60
      ix=l(k)
      l(k)=l(iq)
      l(iq)=ix
      iq=iq-1
      goto 80
60    iq=iq-1
      goto 50
70    continue
      iq=k-1
      goto 100
80    k=k+1
      goto 40
90    continue
100   l(i)=l(iq)
      l(iq)=itt
      if(2*iq-i-j)120,120,110
110   ilt(m)=i
      iut(m)=iq-1
      i=iq+1
      goto 130
120   ilt(m)=iq+1
      iut(m)=j
      j=iq-1
130   m=m+1
      goto 20
140   if(i-j)150,170,170
150   li=l(i)
      lj=l(j)
      if(a(li)-a(lj))170,170,160
160   ix=l(i)
      l(i)=l(j)
      l(j)=ix
170   m=m-1
      if(m)190,190,180
180   i=ilt(m)
      j=iut(m)
      goto 20
190   continue
      return
      end

      subroutine initt(linein,lineno)

C     Reads cards from the input file as character strings
C     for subroutine DIGITS

      common /units/ ibin,incrd,nout,inf

      character*80 linein
 1    continue
      read(incrd,1000,end=10) linein
1000  format(a80)
      if (linein(1:1).eq.'#') goto 1
      lineno = lineno + 1
      return

10    continue
      write(nout,1001) lineno
1001  format(/' ERROR - end of file encountered unexpectedly',
     1       ' after line number ',i4//
     2       ' PROGRAM FORCED TO TERMINATE'///)
      call endall
      end

      subroutine fatal(lineno,linein)

C     Fatal error has occured on input !
C     Print message and stop program

      common /units/ ibin,incrd,nout,inf
      character*80   linein

      write(nout,1000) lineno,linein
1000  format(/' Reading line number ',i4,' of input file'/
     1        ' Line in question is as follows :'/
     1        1x,a80//
     1        ' PROGRAM FORCED TO TERMINATE'///)

      call endall
 10   return
      end

      subroutine filein(fname,itype,alfa,step,omeg)

C     Opens input file if it exists and reads data limits
C     and step size.
C     Postions file at correct point

      common /units/ ibin,incrd,nout,inf

      character*30 fname
      character*80 ttext
      character*6  datn
      logical      error
      double precision alfa,step,omeg

C     Set OMEG to 180 degrees if it is given as 0.0

      if (omeg.eq.0.0) omeg = 18000.0d0

      call gfile(inf,fname,'ORO','FOR',0,error,nout)

      if (error) then
          write(nout,1000)
 1000     format(/' Program forced to terminate'///)
          stop
      endif

 2    continue

      read(inf,1002) ttext
 1002 format(a80)
      if (ttext(1:1).eq.'#') goto 2

               if (itype.eq.1) then

C     D1A or D2B type data

               read(inf,1003,err=4,end=5) step,start
 1003          format(16x,f8.4/f8.3/)
               start = start * 100.0d0
               step  = step  * 100.0d0

               else if (itype.eq.3) then

C     PDS type data from Daresbury Synchrotron

               read(inf,1004,err=4,end=5) start,step,end
 1004          format(/3f9.0)
               start = start * 100.0d0
               step  = step  * 100.0d0

               endif

C     Calculate number of lines of data to be skipped

               if (alfa.le.start) then
               alfa  = start
               nskip = 0

               else
               skip = (alfa - start) / step

                    if (itype.eq.1) then
                    nvall = 10
                    else if (itype.eq.3) then
                    nvall = 5
                    else
                    nvall = 1
                    endif

               skip = skip / nvall
               nskip = skip
               alfa  = start + (nskip * step * nvall)

               endif

C     Skip over unwanted lines

      do 3 j = 1,nskip
      read(inf,2004,end=5) junk
 2004 format(a1)
 3    continue

               if (itype.eq.1) then
               datn = 'D1A    '
               else if (itype.eq.2) then
               datn = 'HARWELL'
               else if (itype.eq.3) then
               datn = 'PDS    '
               endif

      write(nout,1005) datn,fname,ttext
 1005 format(/' Data read in ',a6,' format from file ',a30//
     &       1x,a80/)

      if (nskip.gt.0) write(nout,1006) nskip
 1006 format(10x,i5,' records skipped'/)

      return

 4    continue
      write(nout,1007) fname
 1007 format(/' INPUT ERROR - when reading from file : ',a30/
     &        ' PROGRAM FORCED TO TERMINATE'///)
      call endall

 5    continue
      write(nout,1008) fname
 1008 format(/' ERROR - end of file encountered',
     &        ' when reading from file : ',a30/
     &        ' PROGRAM FORCED TO TERMINATE'///)
      call endall

      end
